#ifndef __ENVIRONMENT
#define __ENVIRONMENT

#include "lisp.h"

struct env_item_struct{
  list value;
  char *name;
  int traced;
  struct env_item_struct *next;
};

#define EMPTYENV (environment) NULL

int is_bounded(char *name, environment local_env);

list get_value(char *name, environment local_env);

void trace(char *name, environment local_env);

void untrace(char *name, environment local_env);

environment set_value(char *name, list l, environment env);

environment set_list_value(list l, list v, environment env, int traced);

environment set_list_let_value(list l, environment env);

void free_env(int n, environment env);

#endif
