#ifndef __LIST_ADD
#define __LIST_ADD

#include "environment.h"

list caar(list l);

list cadr(list l);

list cddr(list l);

list caddr(list l);

list cadddr(list l);

list cadar(list l);

int length(list l);

char *list_to_string(list l);

double list_to_num(list l);

int is_true(list l);

int is_false(list l);

list list_true();

list list_false();

int is_a_var(list l);

list map(list l, list (*f)(list, environment), environment env);

void free_list(list l);

#endif
